///////////////////////////////////////
//
//	CComuNX	F@VAʐMNX
//
///////////////////////////////////////

#include "stdafx.h"
#include "AXCAC01.h"

#include "comu.h"

///////////////////////////////////////
// CComu NX

CComu::CComu()
{
	m_hComm = NULL;											//ٸر
}

CComu::~CComu()
{
}

BOOL CComu::MyOpenPort(LPTSTR lpszPortName)
{
	DCB				PortDCB;

  // Open the serial port.
	m_hComm = CreateFile (lpszPortName, // Pointer to the name of the port
	                      GENERIC_READ | GENERIC_WRITE,   // Access (read-write) mode
	                      0,            // Share mode
	                      NULL,         // Pointer to the security attribute
	                      OPEN_ALWAYS,//OPEN_EXISTING,// How to open the serial port
	                      FILE_ATTRIBUTE_NORMAL, //0,            // Port attributes
	                      NULL);        // Handle to port with attribute
	                                    // to copy

  // If it fails to open the port, return FALSE.
	if ( m_hComm == INVALID_HANDLE_VALUE ) 
		return FALSE;

	PortDCB.DCBlength = sizeof(DCB);     

  // Get the default port setting information.
	if(!GetCommState (m_hComm, &PortDCB))
		return FALSE;

  // Change the DCB structure settings.
	PortDCB.BaudRate		= CBR_115200;			// Current baud 
	PortDCB.fBinary			= TRUE;					// Binary mode; no EOF check 
	PortDCB.fParity			= TRUE;					// Enable parity checking 
	PortDCB.fOutxCtsFlow	= TRUE;					// No CTS output flow control 
//	PortDCB.fOutxCtsFlow	= FALSE;				// No CTS output flow control 
	PortDCB.fOutxDsrFlow	= TRUE;					// No DSR output flow control 
  	PortDCB.fDtrControl		= DTR_CONTROL_ENABLE;	// DTR flow control type 
	PortDCB.fDsrSensitivity = TRUE;					// DSR sensitivity 
//	PortDCB.fDsrSensitivity = FALSE;				// DSR sensitivity 
	PortDCB.fTXContinueOnXoff = FALSE;				// XOFF continues Tx 
	PortDCB.fOutX			= FALSE;				// No XON/XOFF out flow control 
	PortDCB.fInX			= FALSE;				// No XON/XOFF in flow control 
	PortDCB.fErrorChar		= TRUE;					// Disable error replacement 
//	PortDCB.fErrorChar		= FALSE;				// Disable error replacement 
	PortDCB.fNull			= FALSE;				// Disable null stripping 
	PortDCB.fRtsControl		= RTS_CONTROL_ENABLE;	// RTS flow control 
	PortDCB.fAbortOnError	= FALSE;				// Do not abort reads/writes on error
	PortDCB.ByteSize		= 8;					// Number of bits/byte, 4-8 
	PortDCB.Parity			= NOPARITY;				// 0-4=no,odd,even,mark,space 
	PortDCB.StopBits		= ONESTOPBIT;		    // 0,1,2 = 1, 1.5, 2 

  // Configure the port according to the specifications of the DCB 
  // structure.
	DWORD dwError;
	if (!::SetCommState (m_hComm, &PortDCB))
	{
		dwError = GetLastError();
		return FALSE;
	}
  // Retrieve the time-out parameters for all read and write operations
  // on the port. 
	COMMTIMEOUTS	cto;
	::GetCommTimeouts(m_hComm, &cto);
	cto.WriteTotalTimeoutConstant 	= WRITE_TOTAL_TIMEOUT;
	cto.ReadTotalTimeoutConstant  	= READ_TOTAL_TIMEOUT;
	cto.ReadIntervalTimeout       	= READ_INTERVAL_TIMEOUT;
	cto.ReadTotalTimeoutMultiplier	= READ_TOTAL_TIMEOUT;
	::SetCommTimeouts(m_hComm, &cto);

	return TRUE;
}

void CComu::MyClosePort()
{
	if(m_hComm == INVALID_HANDLE_VALUE || m_hComm == NULL) 		//߰Ă݂ĂȂꍇ͏Ȃ
		return;

	if (m_hComm){
		CloseHandle(m_hComm);									//߰ĸ۰
		m_hComm = NULL;
	}
}

BOOL CComu::MyWritePort(LPBYTE lpData, DWORD dwLen)
{
	DWORD	dwWritten;

	BOOL	bRet = WriteFile(m_hComm, lpData, dwLen, &dwWritten, NULL);	//ްM

	if (bRet && (dwLen != dwWritten))									//MsorMްs̏ꍇ
		bRet = FALSE;

	return	bRet;
}

DWORD CComu::MyReadPort(LPBYTE lpData, DWORD dwLen)
{
	DWORD	dwRead = 0;

	BOOL	bRet = ReadFile(m_hComm, lpData, dwLen, &dwRead, NULL);	//ްM

	return	dwRead;													//Mςް
}

