'*****************************************************************************
'*	axcac01s.vb
'*
'*	AXC-AC01
'*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'*	Date Sep.2004
'*
'*****************************************************************************

Option Explicit On 
Imports System.Runtime.InteropServices

Public Class Form1
    Inherits System.Windows.Forms.Form
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Dim m_bErr As Boolean 'G[mptO

#Region "Win32API"
    '// Win32 API
    <DllImport("AXCCom.dll")> Private Shared Function Initialize(ByVal hWnd As Int32, ByVal lBaudRate As Int32, ByVal lLength As Int32, ByVal lParity As Int32, ByVal lStop As Int32) As Int32
    End Function
    <DllImport("AXCCom.dll")> Private Shared Function Terminate() As Int32
    End Function
    <DllImport("AXCCom.dll")> Private Shared Function SetComTimeout(ByVal lReadTimeout As Int32, ByVal lWriteTimeout As Int32) As Int32
    End Function
    <DllImport("AXCCom.dll")> Private Shared Function OpenPort(ByVal lPort As Int32) As Int32
    End Function
    <DllImport("AXCCom.dll")> Private Shared Function ClosePort() As Int32
    End Function
    <DllImport("AXCCom.dll")> Private Shared Function SendSerialData(ByVal Buffer As Byte(), ByVal lDataLen As Int32) As Int32
    End Function
    <DllImport("AXCCom.dll")> Private Shared Function GetSerialData(ByVal Buffer As Byte(), ByVal lDataLen As Int32) As Int32
    End Function
    <DllImport("AXCCom.dll")> Private Shared Function GetComPortNo(ByVal lpFileName As String) As Int32
    End Function
#End Region

#Region " Windows tH[ fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

        m_bErr = False

        Call OnCreate()                 '
        If m_bErr = True Then
            Exit Sub
        End If

        Call OnADContinuousSampling()   'A/DATvO
        If m_bErr = True Then
            Exit Sub
        End If

        Call OnADSingleSampling()       'A/DVOTvO
        If m_bErr = True Then
            Exit Sub
        End If

        Call OnDAOutput()               'D/Ao͏
        If m_bErr = True Then
            Exit Sub
        End If

        Call OnGPIO()                   'GPIO
        If m_bErr = True Then
            Exit Sub
        End If

        Call OnDestroy()                'I

    End Sub

    ' Form ́AR|[lgꗗɌ㏈s邽߂ dispose I[o[Ch܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    'Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^gĕύXȂłB
    Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        '
        'Form1
        '
        Me.Menu = Me.MainMenu1
        Me.Text = "AXC-AC01"

    End Sub

#End Region

    '
    Private Sub OnCreate()
        Dim lRet As Int32           'e֐̖߂li[p
        Dim lPort As Int32          '|[gԍi[p
        Dim byBuffer(255) As Byte   'M/Mf[^i[p
        Dim i As Int16              'JE^p
        Dim strResult As String     'Mi[p

        '=========================================================================
        'COM|[gJ
        '=========================================================================

        lRet = Initialize(0, 115200, 8, 0, 0)   'ʐM̐ݒ
        lPort = GetComPortNo("AXC")             'ʐM|[gԍw
        lRet = SetComTimeout(1000, 1000)        '^CAEgwF1b/1b
        lRet = OpenPort(lPort)                  '|[gJ

        '=========================================================================
        'foCXR}h(RSR}h)𑗐MB
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("R")
        byBuffer(1) = Asc("S")
        byBuffer(2) = &HD
        lRet = SendSerialData(byBuffer, 3)
        If lRet = 0 Then
            Call TimeoutMessage("RS")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'ID₢킹R}h(QUR}h)𑗐MA
        '擾foCX̂bZ[W{bNXɂĕ\B
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("Q")
        byBuffer(1) = Asc("U")
        byBuffer(2) = &HD
        lRet = SendSerialData(byBuffer, 3)
        If lRet = 0 Then
            Call TimeoutMessage("QU")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 256)
        If lRet = 0 Then
            Call TimeoutMessage("QU")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        strResult = Chr(byBuffer(0))
        For i = 1 To lRet
            strResult = strResult & Chr(byBuffer(i))
        Next i

        '擾foCX̂bZ[W{bNXɂĕ\B
        'X|Xf[^́uCARD ID NO. AXC-AC01 Rev.xxxxv
        'قȂ郌X|Xf[^Mꍇ́AvOIB
        If Mid(strResult, 1, 25) = "CARD ID NO. AXC-AC01 Rev." Then
            MsgBox("Device Name: AXC-AC01", vbOKOnly + vbInformation, "Sample")
        Else
            Call ErrorMessage("QU")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'X|X[hؑփR}h(RM1R}h)𑗐MA
        'R}hX|XoCi[hݒɂ
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("R")
        byBuffer(1) = Asc("M")
        byBuffer(2) = Asc("1")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("RM")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("RM")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'RM1̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("RM")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

    End Sub

    'A/DATvO
    Private Sub OnADContinuousSampling()
        Dim lRet As Int32           'e֐̖߂li[p
        Dim byBuffer(255) As Byte   'M/Mf[^i[p 
        Dim i As Int16              'JE^p
        Dim strBufH As String       'Mf[^i[p
        Dim strBufL As String       'Mf[^i[p
        Dim strTmp As String        'bZ[W\p        

        '=========================================================================
        '͏ݒR}h(ADR}h)𑗐MA
        'VOGh͂ɐݒɂB
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("A")
        byBuffer(1) = Asc("D")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("AD")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("AD")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'AD0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("AD")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'TvOIR}h(SC, SK, SUR}h)𑗐MA
        'TvO 10.2[s] ɐݒɂB
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("S")
        byBuffer(1) = Asc("C")
        byBuffer(2) = Asc("1")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("SC")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("SC")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'SC1̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("SC")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("S")
        byBuffer(1) = Asc("K")
        byBuffer(2) = Asc("1")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("SK")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("SK")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'SK1̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("SK")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("S")
        byBuffer(1) = Asc("U")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("SU")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("SU")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'SU0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("SU")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'f[^IR}h(MLR}h)𑗐MA
        'f[^ 1024 ɐݒɂB
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("M")
        byBuffer(1) = Asc("L")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("ML")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("ML")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'ML0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("ML")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'OgK\[XIR}h(TSR}h)𑗐MA
        'OgK͐MɐݒɂB
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("T")
        byBuffer(1) = Asc("S")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("TS")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("TS")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'TS0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("TS")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'bZ[W{bNXɂāA
        'uA/D Sampling Setting
        '  Condition: Single-ended
        '@Rate: 10.2s
        '@Memory Data: 1024
        '@EXT Trigger: Disablev
        'ƕ\B
        '=========================================================================

        'bZ[W\
        strTmp = "A/D Sampling Setting" & Chr(10) _
               & "Condition: Single-ended" & Chr(10) _
               & "Rate: 10.2s" & Chr(10) _
               & "Memory Data: 1024" & Chr(10) _
               & "EXT Trigger: Disable "
        Call ResultMessage(strTmp)

        '=========================================================================
        'gKR}h(TGR}h)𑗐MB
        'AD-DMAJnX|XMAAD-DMAX|XM҂ɓB
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("T")
        byBuffer(1) = Asc("G")
        byBuffer(2) = &HD
        lRet = SendSerialData(byBuffer, 3)
        If lRet = 0 Then
            Call TimeoutMessage("TG")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("TG")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'TG̃X|Xf[^u02H 01Hv(AD-DMAJnX|X)łȂꍇ
        'vOIB
        If byBuffer(0) <> 2 Or byBuffer(1) <> 1 Then
            Call ErrorMessage("TG")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'AD-DMAX|XMAf[^]R}h(BBR}h)𑗐MA
        'Ch0̃TvOf[^擾B
        '=========================================================================

        'AD-DMAX|XM
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("TG")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^u02H 03Hv(AD-DMAX|X)łȂꍇ
        'vOIB
        If byBuffer(0) <> 2 Or byBuffer(1) <> 3 Then
            Call ErrorMessage("TG")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("B")
        byBuffer(1) = Asc("B")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("BB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '=========================================================================
        'bZ[W{bNXɂāA擾f[^\B
        '\f[^͐擪40f[^ƂB
        'uA/D Sampling Data -Ch0
        '  xxxxh,xxxxh,xxxxh,xxxxh,
        '  xxxxh,xxxxh,xxxxh,xxxxh,
        '  .....
        '  xxxxh,xxxxh,xxxxh,xxxxh
        'ƕ\B
        '=========================================================================

        'X|Xf[^擾
        lRet = GetSerialData(byBuffer, 256)
        If lRet = 0 Then
            Call TimeoutMessage("BB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'BB0̃X|Xf[^̐擪oCgu20Hv(Ch0f[^M)łȂꍇ
        'vOIB
        If byBuffer(0) <> 32 Then
            Call ErrorMessage("BB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        '2oCgǂݎ̂
        '擪40f[^\
        strTmp = "A/D Sampling Data - Ch0" & Chr(10)
        For i = 3 To 81 Step 2
            strTmp = strTmp & LCase(Hex(byBuffer(i) * 256 + byBuffer(i + 1)) & "h,")
        Next i

        i = Len(strTmp)
        strTmp = Mid(strTmp, 1, i - 1)

        Call ResultMessage(strTmp)

        'Mobt@̃NA
        While lRet <> 0
            lRet = GetSerialData(byBuffer, 256)
        End While

    End Sub

    'A/DVOTvO
    Private Sub OnADSingleSampling()
        Dim lRet As Int32           'e֐̖߂li[p
        Dim byBuffer(255) As Byte   'M/Mf[^i[p
        Dim strBufH(1) As String    'Mf[^i[p
        Dim strBufL(1) As String    'Mf[^i[p
        Dim strBuf(1) As String
        Dim strTmp As String        'bZ[W\p

        '=========================================================================
        'Ch0Ch1 1f[^ϊR}h(CB2R}h)𑗐MATvOf[^擾B
        'bZ[W{bNXɂāA擾f[^\B
        'uA/D Single Sampling Data
        '  Ch0: xxxxh
        '  Ch1: xxxxhv
        'ƕ\B
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("C")
        byBuffer(1) = Asc("B")
        byBuffer(2) = Asc("2")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("CB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 256)
        If lRet = 0 Then
            Call TimeoutMessage("CB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'CB2R}h̃X|Xf[^̐擪oCgu12HvłȂꍇ
        'vOIB
        If byBuffer(0) <> 18 Then
            Call ErrorMessage("CB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        strBuf(0) = LCase(Hex(byBuffer(1) * 256 + byBuffer(2)))
        strBuf(1) = LCase(Hex(byBuffer(3) * 256 + byBuffer(4)))

        'bZ[W\
        strTmp = "A/D Sampling Data" & Chr(10) _
            & "Ch0: " & strBuf(0) & "h" & Chr(10) _
            & "Ch1: " & strBuf(1) & "h"

        Call ResultMessage(strTmp)

    End Sub

    'DAo͏
    Private Sub OnDAOutput()
        Dim lRet As Int32           'e֐̖߂li[p
        Dim byBuffer(255) As Byte   'M/Mf[^i[p
        Dim strTmp As String        'bZ[W\p

        '=========================================================================
        'DACo̓R}h(DBR}h)𑗐MACh0D/Ao͂B
        'o͒ĺAu0555hvƂB
        'bZ[W{bNXɂāA擾f[^\B
        'uD/A Output - Ch0
        '  Value: 0555hv
        'ƕ\B
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("D")
        byBuffer(1) = Asc("B")
        byBuffer(2) = Asc("0")
        byBuffer(3) = Asc(" ")
        byBuffer(4) = Hex(5)
        byBuffer(5) = Hex(55)
        byBuffer(6) = &HD
        lRet = SendSerialData(byBuffer, 7)
        If lRet = 0 Then
            Call TimeoutMessage("DB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^擾
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("DB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'DB0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("DB")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'bZ[W\
        strTmp = "D/A Output - Ch0" & Chr(10) _
            & "Value: 0555h"

        Call ResultMessage(strTmp)

    End Sub

    'GPIO
    Private Sub OnGPIO()
        Dim lRet As Int32           'e֐̖߂li[p
        Dim byBuffer(255) As Byte   'M/Mf[^i[p
        Dim iRet(3) As Int16        'Mf[^i[p
        Dim strTmp As String        'bZ[W\p

        '=========================================================================
        '|[g@\IR}h(GA, GB, GC, GDR}h)𑗐MA
        'e|[g|[g͂ɐݒ肷B
        'bZ[W{bNXɂāA
        'uGPIO Port Setting
        '  Port A: Input
        '  Port B: Input
        '  Port C: Input
        '  Port D: Inputv
        'ƕ\B
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("A")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GA0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GA0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GA0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GA0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("B")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GB0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GB0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GB0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GB0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("C")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GC0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GC0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GC0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GC0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("D")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GD0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GD0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GD0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GD0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'bZ[W\
        strTmp = "GPIO Port Setting" & Chr(10) _
            & "Port A: Input" & Chr(10) _
            & "Port B: Input" & Chr(10) _
            & "Port C: Input" & Chr(10) _
            & "Port D: Input"
        Call ResultMessage(strTmp)

        '=========================================================================
        'GPIOݒ₢킹R}h(QPR}h)𑗐MAGPIOl擾B
        'bZ[W{bNXɂāA
        'uGPIO InPort Data
        '  Port A: x
        '  Port B: x
        '  Port C: x
        '  Port D: xv
        'ƕ\Bx͎擾lB
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("Q")
        byBuffer(1) = Asc("P")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("QP0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 1)
        If lRet = 0 Then
            Call TimeoutMessage("QP0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If
        iRet(0) = byBuffer(0)

        'R}hM
        byBuffer(0) = Asc("Q")
        byBuffer(1) = Asc("P")
        byBuffer(2) = Asc("1")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("QP1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 1)
        If lRet = 0 Then
            Call TimeoutMessage("QP1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If
        iRet(1) = byBuffer(0)

        'R}hM
        byBuffer(0) = Asc("Q")
        byBuffer(1) = Asc("P")
        byBuffer(2) = Asc("2")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("QP2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 1)
        If lRet = 0 Then
            Call TimeoutMessage("QP2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If
        iRet(2) = byBuffer(0)

        'R}hM
        byBuffer(0) = Asc("Q")
        byBuffer(1) = Asc("P")
        byBuffer(2) = Asc("3")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("QP3")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 1)
        If lRet = 0 Then
            Call TimeoutMessage("QP3")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If
        iRet(3) = byBuffer(0)

        'bZ[W\
        strTmp = "GPIO InPort Data" & Chr(10) _
            & "Port A: " & iRet(0) & Chr(10) _
            & "Port B: " & iRet(1) & Chr(10) _
            & "Port C: " & iRet(2) & Chr(10) _
            & "Port D: " & iRet(3)
        Call ResultMessage(strTmp)

        '=========================================================================
        '|[g@\IR}h(GA, GB, GC, GDR}h)𑗐MA
        'e|[gvbVvo͂ɐݒ肷B
        'bZ[W{bNXɂāA
        'uGPIO Port Setting
        '  Port A: Push-Pull Output
        '  Port B: Push-Pull Output
        '  Port C: Push-Pull Output
        '  Port D: Push-Pull Outputv
        'ƕ\B
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("A")
        byBuffer(2) = Asc("2")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GA2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GA2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GA2̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GA2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If


        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("B")
        byBuffer(2) = Asc("2")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GB2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GB2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GB2̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GB2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("C")
        byBuffer(2) = Asc("2")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GC2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GC2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GC2̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GC2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("G")
        byBuffer(1) = Asc("D")
        byBuffer(2) = Asc("2")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("GD2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("GD2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'GD2̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("GD2")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'bZ[W\
        strTmp = "GPIO Port Setting" & Chr(10) _
            & "Port A: Push-Pull Output" & Chr(10) _
            & "Port B: Push-Pull Output" & Chr(10) _
            & "Port C: Push-Pull Output" & Chr(10) _
            & "Port D: Push-Pull Output"
        Call ResultMessage(strTmp)

        '=========================================================================
        'GPIO|[go̓R}h(PA, PB, PC, PDR}h)𑗐MA
        'Port A, Port C  0 APort B, Port D  1 o͂B
        'bZ[W{bNXɂāA
        'uGPIO Output Data
        '  Port A: 0
        '  Port B: 1
        '  Port C: 0
        '  Port D: 1v
        'ƕ\B
        '=========================================================================

        'R}hM
        byBuffer(0) = Asc("P")
        byBuffer(1) = Asc("A")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("PA0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("PA0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'PA0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("PA0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("P")
        byBuffer(1) = Asc("B")
        byBuffer(2) = Asc("1")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("PB1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("PB1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'PB1̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("PB1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'R}hM
        byBuffer(0) = Asc("P")
        byBuffer(1) = Asc("C")
        byBuffer(2) = Asc("0")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("PC0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("PC0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'PC0̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("PC0")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If


        'R}hM
        byBuffer(0) = Asc("P")
        byBuffer(1) = Asc("D")
        byBuffer(2) = Asc("1")
        byBuffer(3) = &HD
        lRet = SendSerialData(byBuffer, 4)
        If lRet = 0 Then
            Call TimeoutMessage("PD1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'X|Xf[^M
        lRet = GetSerialData(byBuffer, 2)
        If lRet = 0 Then
            Call TimeoutMessage("PD1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'PD1̃X|Xf[^u00H 00HvłȂꍇ̓vOIB
        If byBuffer(0) <> 0 Or byBuffer(1) <> 0 Then
            Call ErrorMessage("PD1")
            Call OnDestroy()
            m_bErr = True
            Exit Sub
        End If

        'bZ[W\
        strTmp = "GPIO Output Data" & Chr(10) _
            & "Port A: 0" & Chr(10) _
            & "Port B: 1" & Chr(10) _
            & "Port C: 0" & Chr(10) _
            & "Port D: 1"
        Call ResultMessage(strTmp)

    End Sub

    'I
    Private Sub OnDestroy()

        '=========================================================================
        'COM|[gN[YB
        '=========================================================================
        Call Terminate()

    End Sub

    ' ʃbZ[W\
    Private Sub ResultMessage(ByVal strMsg As String)

        MsgBox(strMsg, vbOKOnly + vbInformation, "AXC-AC01 Sample")

    End Sub

    ' G[bZ[W\
    Private Sub ErrorMessage(ByVal strCmd As String)
        Dim strMsg As String

        strMsg = "Command Response Error!" & Chr(10) & Chr(10) & _
                 "Command Name: " & _
                 strCmd

        MsgBox(strMsg, vbOKOnly + vbCritical, "Sample Error!")

    End Sub

    '^CAEgbZ[W\
    Private Sub TimeoutMessage(ByVal strCmd As String)
        Dim strMsg As String

        strMsg = "Command Timeout Error!" & Chr(10) & Chr(10) _
                & "Command Name: " _
                & strCmd

        MsgBox(strMsg, vbOKOnly + vbCritical, "Sample Error!")

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '=========================================================================
        'vOIB
        '=========================================================================
        MyBase.Close()

    End Sub
End Class
